 love.graphics.setDefaultFilter("nearest", "nearest")
 enemy = {}
 enemies_controller = {}
 enemies_controller.enemies = {}
 enemies_controller.image = love.graphics.newImage("enemy.png")
-- particle_systems = {}
-- particle_systems.img = love.graphics.newImage('particle.png')
-- i dont get 
-- function particle_systems:spawn(x, y)
--   local ps = love.graphics.newParticleSystem(particle_systems.img, 32)
--   ps:setParticleLifetime(2, 4)
--  ps:setEmissionRate(5)
--  ps:setSizeVariation(1)
--   ps:setLinearAcceleration(1)
--   ps:setColors(100, 255, 100, 0, 255, 0)
--   table.insert(particle_systems.lists, ps)
-- end
-- function particle_systems:draw()
--   for _, v in pairs(particle_systems.list) do
--     love.graphics.draw(v.ps, v.x, v.y)
--   end
-- end
-- function particle_systems:cleanup()
--   
-- end
-- 
 function checkCollisions(enemies, bullets)
 for i,e in ipairs(enemies) do
   for _,b in pairs(bullets) do
    if b.y <= e.y + e.height and b.x > e.x and b.x < e.x + e.width  then
       love.audio.play(enemy_mortesound)
       table.remove(enemies, i)
        end
   end
  end
 end 

-- the game
function love.load()
  game_over = false
  game_win = false
  background_image = love.graphics.newImage('background.png')
  background_sound = love.audio.newSource('loopmusic.mp3')
	player = {}
	player.x = 0
	player.y = 110
	player.speed = 3
  player.image = love.graphics.newImage('player.png')
  player.fire_sound = love.audio.newSource("laser_shoot.wav")
  player.morte_sound = love.audio.newSource("player_morte.wav")
  enemy_mortesound = love.audio.newSource("enemy_morte.wav")
	player.bullets = {}
	player.cooldown = 11
	player.fire = function()
    
	if player.cooldown <= 0 then
    love.audio.play(player.fire_sound)
		player.cooldown = 11
		bullet = {}
		bullet.x = player.x + 3
		bullet.y = player.y - 1
		table.insert(player.bullets, bullet)
    end
  end
 
  for i=0, 7 do
  enemies_controller:spawnEnemy(i*20, 0)
  end
end

function enemies_controller:spawnEnemy(x, y)
  enemy = {}
  enemy.x = x
  enemy.y = y
  enemy.width = 10
  enemy.height = 19
  enemy.bullets = {}
  enemy.cooldown = 20
  enemy.speed = .1
  table.insert(self.enemies, enemy)
end

function enemy:fire()
  if self.cooldown <= 0 then
		self.cooldown = 11
		bullet = {}
		bullet.x = self.x + 7
		bullet.y = self.y
		table.insert(self.bullets, bullet)
	end
end

function love.draw()
  love.graphics.scale(5)
  love.graphics.draw(background_image)
  love.audio.play(background_sound)
  if game_over then
    print("Working...")
    love.audio.play(player.morte_sound)
    love.graphics.print("You Lose!")
    return
  elseif game_win then
    print("That's working too")
    love.graphics.print("You Win!")
  end
  --  O Cara 
	love.graphics.setColor(11, 31, 255)
	love.graphics.draw(player.image, player.x, player.y, 0, 1)
  -- Us zomi
  love.graphics.setColor(255, 255, 255)
  for _,e in pairs(enemies_controller.enemies) do
      love.graphics.draw(enemies_controller.image, e.x, e.y, 0, 1)
    end
  -- As bala da 38 do cara
  love.graphics.setColor(255, 255, 255)
	for _,b in pairs(player.bullets) do 
		love.graphics.rectangle("fill", b.x, b.y, 3 , 3)
	end
end

function love.update(dt)
  --cooldown do cara
	player.cooldown = player.cooldown - 1
	if love.keyboard.isDown("right") then
		player.x = player.x + player.speed
	elseif love.keyboard.isDown("left") then
		player.x = player.x - player.speed
	end

	if love.keyboard.isDown("x") then
		player.fire()
	end
  -- para dizer se esse ohm ganhô
  if #enemies_controller.enemies == 0 then
    game_win = true
  end
  
  for _,e in pairs(enemies_controller.enemies) do
   if e.y >= love.graphics.getHeight()/5 then
     game_over = true
   end
   e.y = e.y + 1 * e.speed
  end
  
	for i, b in pairs(player.bullets) do
		if b.y < -10 then
			table.remove(player.bullets, i)
		end
		b.y = b.y - 2
	end
  
checkCollisions(enemies_controller.enemies, player.bullets)
end